Attribute VB_Name = "CmDialog"
Public Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Type RetOpenFile
 FilePath As String
 FileTitle As String
 FilterIndex As Integer
End Type

Public Type ChooseColor
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Public Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
'  General Declarations
Dim CustomColors() As Byte

Function GetFileName(ParentHandle As Long, OpenSave As Integer) As RetOpenFile
'Const OpenBox As Integer = 1, SaveBox As Integer = 2

Const OFN_EXPLORER = &H80000
Const OFN_FILEMUSTEXIST = &H1000
Const OFN_LONGNAMES = &H200000

Dim ofn As OPENFILENAME
ofn.lStructSize = Len(ofn)
ofn.hwndOwner = ParentHandle
ofn.hInstance = App.hInstance
ofn.lpstrFilter = "Text Files (*.txt)" + Chr$(0) + "*.txt" + Chr$(0) + "Rich Text Files (*.rtf)" + Chr$(0) + "*.rtf" + Chr$(0)
ofn.lpstrFile = Space$(254)
ofn.nMaxFile = 255
ofn.lpstrFileTitle = Space$(254)
ofn.nMaxFileTitle = 255
ofn.lpstrInitialDir = CurDir
ofn.nFilterIndex = 2

Const OFN_ENABLESIZING = &H800000, OFN_PATHMUSTEXIST = &H800
ofn.flags = OFN_EXPLORER Or OFN_LONGNAMES Or OFN_ENABLESIZING Or OFN_PATHMUSTEXIST

Dim Succes As Long
Select Case OpenSave
 Case 1
  ofn.flags = ofn.flags Or OFN_FILEMUSTEXIST
  ofn.lpstrTitle = " "
  Succes = GetOpenFileName(ofn)
 Case 2
  Const OFN_OVERWRITEPROMPT = &H2
  ofn.flags = ofn.flags Or OFN_OVERWRITEPROMPT
  ofn.lpstrTitle = " "
  Succes = GetSaveFileName(ofn)
End Select

If ofn.nFileExtension = 0 And Len(ofn.lpstrFile) > 0 Then
 Select Case ofn.nFilterIndex
 Case 1
  ofn.lpstrFile = ofn.lpstrFile & ".txt"
 Case 2
  '2 User:    ("- 1")
  '''ofn.lpstrFile = Left(ofn.lpstrFile, (InStr(1, ofn.lpstrFile, Chr(0)) - 1)) & ".Rtf" & Chr(0)
  ofn.lpstrFile = Left(ofn.lpstrFile, (InStr(1, ofn.lpstrFile, Chr(0)))) & ".Rtf" & Chr(0)
 End Select
End If

If (Succes) Then
 GetFileName.FilePath = ofn.lpstrFile
 GetFileName.FileTitle = Trim(ofn.lpstrFileTitle)
 GetFileName.FilterIndex = ofn.nFilterIndex
Else
 GetFileName.FilePath = ""
 GetFileName.FileTitle = ""
 GetFileName.FilterIndex = 0
End If
End Function

Public Function GetColor(hWndParent As Long, Color As Long)
Const CC_ANYCOLOR As Long = &H100
Const CC_RGBINIT As Long = &H1

Dim cc As ChooseColor ' structure to pass data
Dim hMem As Long  ' handle to the memory block to store the custom color list
Dim pMem As Long  ' pointer to the memory block to store the custom color list
Dim custcols(0 To 15) As Long  ' holds list of the 16 custom colors
Dim c As Integer  ' counter variable
Dim retval As Long  ' return value

' Initialize the list of custom colors to black.
For c = 1 To 15  ' loop through each element
  custcols(c) = QBColor(c)  ' set each element to RGB color 0 (black)
Next c
custcols(0) = Color
' Create a memory block and get a pointer to it.
hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, 64)  ' allocate sufficient memory block
pMem = GlobalLock(hMem)  ' get a pointer to the block
' Copy the data inside the array into the memory block.
CopyMemory ByVal pMem, custcols(0), 64  ' 16 elements * 4 bytes

' Store the initial settings of the Choose Color box.
cc.lStructSize = Len(cc)  ' size of the structure
cc.hwndOwner = hWndParent  ' Form1 is opening the Choose Color box
cc.hInstance = 0  ' not needed
cc.rgbResult = Color  ' set default selected color to Form1's background color
cc.lpCustColors = pMem  ' pointer to list of custom colors
cc.flags = CC_ANYCOLOR Or CC_RGBINIT  ' allow any color, use rgbResult as default selection
cc.lCustData = 0  ' not needed
cc.lpfnHook = 0  ' not needed
cc.lpTemplateName = ""  ' not needed

' Open the Choose Color box.  If the user chooses a color, set Form1's
retval = ChooseColor(cc)
If retval = 0 Then
 GetColor = -1
Else
 GetColor = cc.rgbResult
  ' Copy the possibly altered contents of the custom color list
  ' back into the array.
  CopyMemory custcols(0), ByVal pMem, 64
End If
' Deallocate the memory blocks to free up resources.
retval = GlobalUnlock(hMem)
retval = GlobalFree(pMem)

End Function
